import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class InvPower extends Frame
{  public int Iter;
   public InvPower()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [] MultMV(double [][] A,double [] B, int N1,int N2)
   {  int i,j,k;
      double [] C = new double[N1];
      for(i=0;i<N1;i++)
      {  C[i]=0.0;
         for(k=0;k<N2;k++) C[i] += A[i][k] * B[k];
      }
      return C;
   }
   public double [][] MultM(double [][] A,double [][] B, int N1,int N2,int N3)
   {  int i,j,k;
      double [][] C = new double[N1][N3];
      for(i = 0; i < N1; i++)for(j = 0; j < N3;j++)
      {  C[i][j]=0.0; for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public void MoveMat(double [][] A, double[][] B, int N, int COL)
   {
      int i,j;
      for(i = 0; i < N; i++)for(j=0; j<N; j++) B[i][j] = A[i][j + COL]; 
   }
   public int InvMat(double [][] A, int N, double Eps)
   {   int i,j,k; double Alfa;int N2 = N * 2;    
       for(i=0;i<N;i++)for(j=0;j<N;j++) A[i][j+N] = (i==j ? 1 : 0);
       for(k = 0; k < N; k++)       
       { if(Math.abs(A[k][k]) < Eps) return 1;
         Alfa=1/A[k][k];int k1=k+1;
         for(j=k1;j<N2;j++) A[k][j] *= Alfa;
         for(i=0;i<N;i++)
            if(i != k)
            { Alfa=A[i][k];
              for(j=k1;j<N2;j++) A[i][j] -= Alfa* A[k][j];
            }
       } 
       return 0;
   }

   public double [] MultSV(double A, double [] B, int N)
   {  int i,j,k;
      double [] C = new double[N];
      for(i = 0; i < N; i++) C[i] = A * B[i];
      return C;
   }
   public double IgenValue(double [][] A, double EPS, double[] X, int N)
   {  double lambda = 0; double T;
      int i,j, K1, K2, IterMax; double[][] XTemp = new double[2][N]; 
      K1 = 1; K2 = 0; IterMax = 100;
      XTemp[K2][0] = 1; for(i = 1; i< N; i++)  XTemp[K2][i] = 0;// Xtemp̏ݒ
      double E = EPS * 100; Iter = 0;
      while(Iter < IterMax && E > EPS)
      {  Iter++; int KK = K2; K2 = K1; K1 = KK;   //  K1FOvZCK2:
         for(i = 0; i < N; i++)   // s񎮂̏Z
         { T = 0; for(j = 0; j < N; j++) T += A[i][j] * XTemp[K1][j];
           XTemp[K2][i] = T;
         }
         // m1=1ɂ@
         T = 0; for(i = 0; i < N; i++) T += XTemp[K2][i]*XTemp[K2][i];
         lambda = Math.sqrt(T);
         if (Math.abs(lambda ) < EPS)
         { E = EPS * 100; break;    // ŗLl0̏ꍇ͎Ȃ̂Ƃ
         }
        for(i = 0; i < N; i++)  XTemp[K2][i] = XTemp[K2][i] / lambda;
        double T1 = 0; double T2 = 0;
        for(i = 0; i < N; i++) 
        {  double DX = XTemp[K2][i] - XTemp[K1][i];
           T1 += DX * DX; T2 += XTemp[K2][i] * XTemp[K2][i];
        }
        if(Math.abs(T2) < EPS)    // ŗLxNg0̂ƂȂ̂Ƃ
        {  E = EPS * 100; break;
        }
        E = T1 / T2;
      }
      for(i = 0; i < N; i++) X[i] = XTemp[K2][i];
      return lambda;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN = 10 * Math.pow(10.0,(double)(N-1));
      double DX =  D * DN; if(Math.abs(DX)<0.5)return 0;
      return Math.rint(DX)/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A,int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<N; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
         }
      }
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      
   } 
   public void DrawMat(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,260,Y + 30);
      g.drawString( ope2,520,Y + 30);
      for(i=0;i<N1;i++)
      { for(j=0;j<N2; j++)
        { g.drawString( "" + round(A[i][j],3),  50 + j*50, Y + i*20);
          g.drawString( "" + round(B[i][j],3), 300 + j*50 , Y + i*20);
          g.drawString( "" + round(C[i][j],3), 550 + j*50 , Y + i*20);
        }
      }  
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      drawBra(g,290, Y - 10, 70); drawKet(g,490, Y - 10, 70);
      drawBra(g,540, Y - 10, 70); drawKet(g,740, Y - 10, 70);
   } 

   public void DrawMatVect(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [] B,double [] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,260,Y + 30);
      g.drawString( ope2,400,Y + 30);
      for(i=0;i<N1;i++)
      { for(j=0;j<N2; j++)g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
        g.drawString( "" + round(B[i],3),300, Y + i*20);
        g.drawString( "" + round(C[i],3),450, Y + i*20);
      }  
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      drawBra(g,290, Y - 10, 70); drawKet(g,350, Y - 10, 70);
      drawBra(g,440, Y - 10, 70); drawKet(g,490, Y - 10, 70);
   } 
   public void DrawScalerVect(Graphics g, String ope1,String ope2, int Y,
                       double A,double [] B,double [] C,int N)
   {  int i, j;
      g.drawString( ope1,260,Y + 30);
      g.drawString( ope2,400,Y + 30);
      g.drawString( ""+ round(A,3),200,Y + 30);
      for(i=0;i<N;i++)
      { g.drawString( "" + round(B[i],3),300, Y + i*20);
        g.drawString( "" + round(C[i],3),450, Y + i*20);
      }  
      //drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      drawBra(g,290, Y - 10, 70); drawKet(g,350, Y - 10, 70);
      drawBra(g,440, Y - 10, 70); drawKet(g,490, Y - 10, 70);
   } 

   public void paint(Graphics g)
   {  int i,j;
      double [][] A  = {{4,2,1,3},{2,3,1,2},{1,1,2,1},{3,2,1,1}};
      double [][] AA = new double [4][8]; 
      double []   B  = {0,0,0,0};
      setTitle("t@ɂŏŗLl");
      g.drawString( "f[^",20,50);
      DrawData(g, 80, A, 4);
      MoveMat(A, AA, 4, 0);int R = InvMat(AA, 4, 0.00001);
      if(R != 0)  g.drawString( "ts߂邱Ƃł܂", 20, 200);
      else
      { MoveMat(AA, AA, 4, 4);
        double lambda = IgenValue(AA, 0.00001, B, 4);
        if(Math.abs(lambda)<0.000001) g.drawString( "ŗLl߂邱Ƃł܂", 20, 200);
        else
        {  lambda = 1 / lambda;
           g.drawString( "mF (JԂ : " + Iter + ")   = "+ lambda, 20, 200);
           double []    C = MultMV(A, B, 4, 4);
           DrawMatVect(g, "","", 240, A, B, C, 4,4);
           C = MultSV(lambda, B, 4);
           DrawScalerVect(g, "","", 340, lambda, B, C, 4);
           g.drawString( "ts̊mF", 20, 450);
           double [][] IA = MultM(A, AA, 4, 4, 4);
           DrawMat(g, "","", 480, A, AA, IA, 4,4);
        }   
      }
   } 
   public static void main(String[] args)
   {  Frame w = new InvPower();
      w.setVisible(true);
   }
}
